module audiobuf (clk, datain,dataaddr,datastb,left,right,audiostb,empty,cs);

// Audio buffer for de2-115 and the Propeller verilog with portb enabled
// v20141012-1534
// Piotr Kardasz, pik33@o2.pl
// GPL 3.0 when using with the Propeller Verilog code
// MIT elsewhere
// Warning: beta quality code, no warranty, use at your own risk

input wire clk;
input wire cs;
input wire [31:0] datain;
input wire [8:0] dataaddr;
input wire datastb;
output reg [23:0] left;
output reg [23:0] right;
input wire audiostb;
output reg [1:0] empty;

reg [31:0] buff [256];
reg [31:0] paula[8];
reg [31:0] adata;
reg [7:0] aaddr;
reg oldaudiostb;
reg olddatastb;
reg signed[15:0] paulal,paular;
reg signed[15:0] dacl,dacr;
initial
  begin
  $readmemh("sinus.hex",buff);
  aaddr<=0;
  empty<=0;
  end
  
  
 always@(posedge clk)
   begin
	oldaudiostb<=audiostb; 
	olddatastb<=datastb;
   paulal<=paula[0][31:16]+paula[1][31:16]+paula[2][31:16]+paula[3][31:16]+paula[4][31:16]+paula[5][31:16]+paula[6][31:16]+paula[7][31:16];
   paular<=paula[0][15:0]+paula[1][15:0]+paula[2][15:0]+paula[3][15:0]+paula[4][15:0]+paula[5][15:0]+paula[6][15:0]+paula[7][15:0];

   if ((audiostb==1) && (oldaudiostb==0)) // posedge audiostb
	  begin
     adata<=buff[aaddr];
	  dacl=adata[31:16];
	  dacr=adata[15:0];
     aaddr<=aaddr+1;
     if (aaddr==128) empty[0]<=1;
     if (aaddr==0) empty[1]<=1;
	  left={dacl+paulal,8'h00};
	  right={dacr+paular,8'h00};
	  oldaudiostb<=audiostb;
	  end
	  
	if ((datastb==1) && (cs==1))// && (olddatastb==0)) // posedge datastb
	  begin
     if (dataaddr<256) buff[dataaddr]<=datain; else paula[dataaddr[2:0]]<=datain;
	  if (dataaddr<128) empty[0]<=0; else if (dataaddr<256) empty[1]<=0;
	  olddatastb<=datastb;
	  end  
	end  
	
endmodule	