module audiodata(
  input wire [23:0] ldata,
  input wire [23:0] rdata,
  output reg [31:0] dataout,
  input wire clk,
  output reg stbout,
  output reg aud_mclk,
  output reg aud_bclk,
  output reg aud_dacdat,
  output reg aud_daclrck,
  output reg aud_adclrck,
  input wire aud_adcdat);
  
reg mcount;
reg [2:0] bcount;
reg [5:0] bbcount;
reg [63:0] lrdata;  
reg [63:0] lrdata2;
reg [63:0] lrdataout;  
reg [63:0] lrdataout2; 
//reg [23:0] ldataout,
//reg [23:0] rdataout,
 
initial
  begin  
  mcount=1;
  bcount=3'b101;
  bbcount=0;
  stbout=0;
  lrdata=0;
  aud_mclk=0;
  aud_bclk=0;
  aud_daclrck=0;
  aud_dacdat=0;
  end
  
  
always
aud_mclk<=clk;

always@(posedge clk)

  begin
  bcount<=bcount-1;
  if (bcount==3'b010) 
	  begin
    aud_bclk=1;
		if (bbcount<63) lrdataout[bbcount+1]<=aud_adcdat;
		end;
	if (bcount==3'b000) 
	  begin
		aud_bclk<=0;
		bcount<=3'b101;
    bbcount<=bbcount-1;
	  if (bbcount==6)  // somewhere between 16 and 0
		  begin
		  stbout<=1;  // on posedge of this new dac data should be set
		  lrdataout2<=lrdataout;                     // adc data latch
		  end
	  else if (bbcount==5)
	    begin 
      stbout<=1;
//		  ldataout<=lrdataout2[63:40];               // adc data out
//		  rdataout<=lrdataout2[39:16];
		dataout<={lrdataout2[63:48],lrdataout2[39:24]};

      lrdata<={ldata[23:0], rdata[23:0],16'b0};  // dac data latch 		  
		  end 
    else if (bbcount==4) // on negedge of this you can receive adcdata    
		  begin
      stbout<=1;
 //     ldataout<=lrdataout2[63:40];
//		rdataout<=lrdataout2[39:16];
		dataout<={lrdataout2[63:48],lrdataout2[39:24]};
		  end
 //   else if (bbcount==2)
 //     begin
//		  lrdata<=lrdata2;
 //     stbout<=0;
//      end
    else stbout<=0;  
  
	  if (bbcount==0) aud_daclrck<=1; else aud_daclrck<=0; 
	  if (bbcount==0) aud_adclrck<=1; else aud_adclrck<=0; 

    if (bbcount>=16) aud_dacdat<=lrdata[bbcount]; else aud_dacdat<=0;

	  end
  end


endmodule